import os
import dicom

from struct import unpack

def getDICOMKeysRecursive(Directory, Recurse=False, keyArray = None):
	DICOMKeys = {}
	FileList = os.listdir(Directory)
	DICOMFiles = []
	for curFile in FileList:
		curFileName = os.path.join(Directory, curFile)
		if os.path.isfile(curFileName):
			if curFile.lower() != 'dicomdir':
				try:
					ds = dicom.filereader.read_file(curFileName, stop_before_pixels = True)
				except Exception, e:
					ds = None

				if ds != None:
					#print curFileName
					#ds = dicom.filereader.ReadHeaderSelectedTags(curFileName, keyArray = keyArray)
					keyValues = DICOMUtilities.convertDICOMKeysFromDStoDict(ds = ds, keyArray = keyArray)
					if keyValues != None:
						DICOMKeys[curFileName] = keyValues
					del ds
			#if curFile.lower() != 'dicomdir':
		elif Recurse and os.path.isdir(curFileName):
			curDICOMKeys = getDICOMKeysRecursive(curFileName, Recurse = Recurse, keyArray = keyArray)
			for curDICOMFile in curDICOMKeys.iterkeys():
				DICOMKeys[curDICOMFile] = curDICOMKeys[curDICOMFile]
		#if os.path.isfile(curFileName):
	#for CurFile in FileList:
	return DICOMKeys
#def getDICOMKeysRecursive(Directory, Recurse=False, keyArray=None):


def convertDICOMKeysFromDStoDict(ds = None, keyArray = None):
	if ds != None:
		keyValues = {}
		for curKey in keyArray.iterkeys():
			curKeyElements = keyArray[curKey].split(',')
			curKeyElements[0] = long(curKeyElements[0], 16)
			curKeyElements[1] = long(curKeyElements[1], 16)
			if (curKeyElements[0], curKeyElements[1]) in ds:
				keyValues[curKey] = ds[curKeyElements[0], curKeyElements[1]].value
			elif (curKeyElements[0], curKeyElements[1]) in ds.file_meta:
				keyValues[curKey] = ds.file_meta[curKeyElements[0], curKeyElements[1]].value
			else:
				keyValues[curKey] = None

		# now do the conversion for dodgy fields 
		if 'imageType' in keyValues:
			keyValues['imageType'] = "\\".join(keyValues['imageType'])
		
		conversionFormats = {}
		conversionFormats['numSlices'] = 'H'
		conversionFormats['samplesPerPixel'] = 'H'
		conversionFormats['bitsAllocated'] = 'H'
		conversionFormats['numRows'] = 'H'
		conversionFormats['numCols'] = 'H'
		conversionFormats['numSlices'] = 'H'
		conversionFormats['BVector'] = 'ddd'
		if 'imageNumber' in keyValues:
			if isinstance(keyValues['imageNumber'], str):
				keyValues['imageNumber'] = int(keyValues['imageNumber'])
		if 'seriesNumber' in keyValues:
			if isinstance(keyValues['seriesNumber'], str):
				keyValues['seriesNumber'] = int(keyValues['seriesNumber'])
		if 'numAverages' in keyValues:
			if isinstance(keyValues['numAverages'], str):
				keyValues['numAverages'] = int(keyValues['numAverages'])
		if 'sliceThickness' in keyValues:
			if isinstance(keyValues['sliceThickness'], str):
				if len(keyValues['sliceThickness']) == 0:
					keyValues['sliceThickness'] = 1
				else:
					keyValues['sliceThickness'] = float(keyValues['sliceThickness'])
		if 'TR' in keyValues:
			if isinstance(keyValues['TR'], str):
				keyValues['TR'] = float(keyValues['TR'])
		if 'TE' in keyValues:
			if isinstance(keyValues['TE'], str):
				keyValues['TE'] = float(keyValues['TE'])
		if 'flipAngle' in keyValues:
			if isinstance(keyValues['flipAngle'], str):
				keyValues['flipAngle'] = float(keyValues['flipAngle'])
		if 'MRFieldStrength' in keyValues:
			if isinstance(keyValues['MRFieldStrength'], str):
				keyValues['MRFieldStrength'] = float(keyValues['MRFieldStrength'])
		if 'slicePosition' in keyValues:
			if isinstance(keyValues['slicePosition'], str):
				keyValues['slicePosition'] = keyValues['slicePosition'].split("\\")
				for idx in range(len(keyValues['slicePosition'])):
					keyValues['slicePosition'][idx] = float(keyValues['slicePosition'][idx])
		if 'sliceOrientation' in keyValues:
			if isinstance(keyValues['sliceOrientation'], str):
				keyValues['sliceOrientation'] = keyValues['sliceOrientation'].split("\\")
				for idx in range(len(keyValues['sliceOrientation'])):
					keyValues['sliceOrientation'][idx] = float(keyValues['sliceOrientation'][idx])

		if 'BValue' in keyValues:
			if isinstance(keyValues['BValue'], str):
				keyValues['BValue'] = float(keyValues['BValue'])

		for curTag in conversionFormats.iterkeys():
			if curTag in keyValues:
				if isinstance(keyValues[curTag], str):
					keyValues[curTag] = unpack(conversionFormats[curTag], keyValues[curTag])
					
					if curTag == 'numSlices' or \
						curTag == 'numSlices' or \
						curTag == 'samplesPerPixel' or \
						curTag == 'bitsAllocated' or \
						curTag == 'numRows' or \
						curTag == 'numCols' or \
						curTag == 'numSlices':
						keyValues[curTag] = keyValues[curTag][0]

		if 'BVector' in keyValues:
			if keyValues['BVector'] != None:
				keyValues['BVector'] = list(keyValues['BVector'])
		return keyValues
	else:
		return None
	#if ds != None:
#def convertDICOMKeysFromDStoDict(ds = None, keyArray = None):
