import pwd
import grp

# returns a dict with keys that are uids and values that are usernames
def getUserList():
	PWDList = pwd.getpwall()

	OutputList = {}

	for curUser in PWDList:
		OutputList[curUser[2]] = curUser[0]
	return OutputList


def getGroupList():
	GRPList = grp.getgrall()

	OutputList = {}

	for curGroup in GRPList:
		OutputList[curGroup[2]] = curGroup[0]
	return OutputList

# given a user id, returns either the user name (if the user exists) or the id if the user does not
def getUserNameOrID(uid):
	try:
		userIDStats = pwd.getpwuid(uid)
		return userIDStats[0]
	except KeyError, e:
		return uid

def getGroupNameOrID(gid):
	try:
		groupIDStats = grp.getgrgid(gid)
		return groupIDStats[0]
	except KeyError, e:
		return gid

