#!/usr/bin/python -u

#import libxml2
import sys
import os
import errno
import getopt
import stat

import DataTransferConstants

import ezPyCrypto

from lxml import etree
#from Crypto.Util import randpool

#from Crypto.PublicKey import RSA

#def print_children(child):
#	while child is not None:
#		print child.name
#		#print child.type
#		if child.type == "element":
#			if child.lsCountNode > 0:
#				print "\tAn element with ", child.lsCountNode(), "child(ren)"
#				print "\tAnd content", repr(child.content)
#				print_children(child.children)
#		child = child.next


def main(): 
	# Memory debug specific
	#libxml2.debugMemory(1)

	# this file adds a project to the hierarchy
	# the project must have a unique ID
	
	opts, args = getopt.getopt(sys.argv[1:], "fp:", ["database-directory="])

	projectName = None
	databaseDirectory = None
	force = False
	for o, a in opts:
		if o == '-p':
			projectName = a
		if o == '-f':
			force = True
		if o == '--database-directory':
			databaseDirectory = a
	
	databaseDirectory = DataTransferConstants.getDatabaseDirectory(databaseDirectory)
	#print databaseDirectory	
	if projectName == None:
		print "Project name not specified on the command line"
		print "Usage: " + sys.argv[0] + " -p <project name> [-f] [--database-directory=<>]"
		print
		print "OPTIONAL:"
		print "\t-f: forces overwrite of existing files"
		quit()

	processOwner = os.getuid()

	# strip slashes off the end of the project name
	projectName = projectName.strip('/')
	if not os.path.isfile(DataTransferConstants.metaDataFileName(databaseDirectory, projectName, "projects.xml")) or force == True:

		if os.path.isfile(DataTransferConstants.metaDataFileName(databaseDirectory, projectName, "projects.xml")) or force == True:
			(st_mode, st_ino, st_dev, st_nlink, st_uid, st_gid, st_size, st_atime, st_mtime, st_ctime) = os.stat(DataTransferConstants.projectDirectory(databaseDirectory, projectName))
			if processOwner != st_uid:
				print "I'm attempting to overwrite the existing project + " + projectName + " and the process owner does not own the project directory, quitting"
				quit()
		#if not os.path.isdir(DataTransferConstants.projectDirectory(databaseDirectory, projectName)):
		#	(st_mode, st_ino, st_dev, st_nlink, st_uid, st_gid, st_size, st_atime, st_mtime, st_ctime) = os.stat(databaseDirectory)

		try:
			os.mkdir(os.path.join(databaseDirectory, projectName))
		except Exception, e:
		    code, st = e
		    if code != errno.EEXIST:
				st = "Error creating directory '%s': %s" % (os.path.join(databaseDirectory, projectName), str(e))
				print st
				print "check that the process owner has write access to the database directory"
				sys.exit(1)
		os.chmod(DataTransferConstants.projectDirectory(databaseDirectory, projectName), stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR | stat.S_IRGRP | stat.S_IWGRP | stat.S_IXGRP | stat.S_ISGID)
	
		# replace libxml2 code with lxml code
		
		#XMLRoot = etree.XML('<html/>')
		#print XMLRoot
		
		XCEDERoot = etree.Element('XCEDE')
		XMLRoot = XCEDERoot.getroottree()
		#CommentNode = etree.SubElement(XMLRoot, 'Master XML file for project ' + projectName)
		projectRoot = etree.SubElement(XCEDERoot, 'project')
		projectRoot.set("ID", projectName)

		projectInfoRoot = etree.SubElement(projectRoot, 'projectInfo')
		subjectGroupListRoot = etree.SubElement(projectInfoRoot, 'subjectGroupList')

		patientsGroupListRoot = etree.SubElement(subjectGroupListRoot, 'subjectGroup')
		patientsGroupListRoot.set("ID", 'patients')
		controlsGroupListRoot = etree.SubElement(subjectGroupListRoot, 'subjectGroup')
		controlsGroupListRoot.set("ID", 'controls')
		
		XMLRoot.write(DataTransferConstants.metaDataFileName(databaseDirectory, projectName, "projects.xml"), encoding=None, method="xml", pretty_print=True, xml_declaration=True)

		K = ezPyCrypto.key(something=1024, algoPub="RSA", algoSess=None)
		privateKeyString = K.exportKeyPrivate()
		publicKeyString = K.exportKey()

		privateKeyFile = file(DataTransferConstants.metaDataFileName(databaseDirectory, projectName, "privatekey.txt"), 'w')
		publicKeyFile = file(DataTransferConstants.metaDataFileName(databaseDirectory, projectName, "publickey.txt"), 'w')
		privateKeyFile.write(privateKeyString)
		publicKeyFile.write(publicKeyString)
		privateKeyFile.close()
		publicKeyFile.close()
		
		nameHashMappingFile = file(DataTransferConstants.metaDataFileName(databaseDirectory, projectName, "namehashmapping.txt"), 'w')
		nameHashMappingFile.write("\"nextID\",\"1\"\n");
		nameHashMappingFile.close()
		
		# create the data directory
		try:
			os.mkdir(DataTransferConstants.projectDataDirectory(databaseDirectory, projectName))
		except Exception, e:
		    code, st = e
		    if code != errno.EEXIST:
				st = "Error creating directory '%s': %s" % (DataTransferConstants.projectDataDirectory(databaseDirectory, projectName), str(e))
				sys.exit(1)
		os.chmod(DataTransferConstants.projectDataDirectory(databaseDirectory, projectName), stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR | stat.S_IRGRP | stat.S_IWGRP | stat.S_IXGRP | stat.S_ISGID)

		#other empty files
		otherEmptyFiles = ['userfields.txt', 'protocols.xml']
		for curEmptyFile in otherEmptyFiles:
			emptyFile = file(DataTransferConstants.metaDataFileName(databaseDirectory, projectName, curEmptyFile), 'w')
			emptyFile.close()

		metaDataFiles = ['projects.xml', 'protocols.xml', 'userfields.txt', 'namehashmapping.txt', 'privatekey.txt', 'publickey.txt']
		for curFile in metaDataFiles:
			os.chmod(DataTransferConstants.metaDataFileName(databaseDirectory, projectName, curFile), stat.S_IRUSR | stat.S_IWUSR | stat.S_IRGRP | stat.S_IWGRP)

		# generate RSA keys
		#os.system('dt_create_keys.pl -s 1024 -p ' + projectName + " -d " + DataTransferConstants.databaseDirectory)
		#r = randpool.RandomPool();
		#r.stir()
		#RSAKey = RSA.generate(1024, r.get_bytes)
		#print RSAKey.privatekey()
		#print RSAKey.publickey()
	else:
		print "Project directory already exists"

if __name__ == "__main__":
    main()

