#!/usr/bin/python

import os
import sys
import getopt
import DataTransferConstants

def usage():
	print "Usage: " + sys.argv[0] + " [--database-directory=<>]"
	print
	print "Prints out a newline separated list of projects in the database directory to standard output"
	print
	print "--database-directory: the root directory of the database"
	print "-h: this help message, program will quit"

def main():
	opts, args = getopt.getopt(sys.argv[1:], "h", ["database-directory="])
	
	databaseDirectory = None

	for o, a in opts:
		if o == '--database-directory':
			databaseDirectory = a
		if o == '-h':
			usage()
			quit()

	databaseDirectory = DataTransferConstants.getDatabaseDirectory(databaseDirectory)

	print "\n".join(DataTransferConstants.projectList(databaseDirectory))

if __name__ == "__main__":
	main()
