#!/usr/bin/python

from lxml import etree

import DataTransferUserFields
import DataTransferConstants

import getopt
import sys
import os

def usage():
	print "Usage: " + sys.argv[0] + " -p <project name> [--database-directory=<>]"
	print
	print "-p <project name>: the project name, the project's directory must exist and be created by dt_create_project.py"
	print
	print "Optional arguments:"
	print "--database-directory=<database directory>: the root directory of where the database is situated"
	print "-h: help (this message)"

def main():
	opts, args = getopt.getopt(sys.argv[1:], "p:h", ["database-directory="])

	projectName = None
	databaseDirectory = None

	for o, a in opts:
		if o == '-p':
			projectName = a
		if o == '-h':
			usage()
			quit()
		if o == '--database-directory':
			databaseDirectory = a
	#for o, a in opts:
	
	databaseDirectory = DataTransferConstants.getDatabaseDirectory(databaseDirectory)

	if projectName != None:
		if DataTransferConstants.isProjectExist(databaseDirectory, projectName) == False:
			quit()
	else:
		print "project name was not given"
		usage()
		quit()
	projectXML = etree.parse(os.path.join(databaseDirectory, projectName, "projects.xml")) 
	projectXMLRoot = projectXML.getroot()
	userFields = DataTransferUserFields.UserFields(projectName=projectName, databaseDirectory=databaseDirectory)
	userFields.addFieldsInXML(projectXMLRoot = projectXMLRoot)

	projectXML.write(os.path.join(databaseDirectory, projectName, "projects.xml"), pretty_print=True)


if __name__ == "__main__":
	main()
