#!/usr/bin/python

from lxml import etree

import DataTransferUserFields
import DataTransferConstants

import getopt
import sys

def usage():
	print "Usage: " + sys.argv[0] + " -p <project name> [--database-directory=<>]"
	print
	print "-p <project name>: the project name, the project's directory must exist and be created by dt_create_project.py, if this is not given, only the database-wide fields will be printed"
	print "--database-directory=<database directory>: the root directory of where the database is situated"
	print
	print "Optional arguments:"
	print "-h: help (this message)"

def main():
	opts, args = getopt.getopt(sys.argv[1:], "p:h", ["database-directory="])

	projectName = None
	databaseDirectory = None

	for o, a in opts:
		if o == '-p':
			projectName = a
		if o == '-h':
			usage()
			quit()
		if o == '--database-directory':
			databaseDirectory = a
	#for o, a in opts:
	
	databaseDirectory = DataTransferConstants.getDatabaseDirectory(databaseDirectory)

	if projectName != None:
		if DataTransferConstants.isProjectExist(databaseDirectory, projectName) == False:
			quit()
	
	userFields = DataTransferUserFields.UserFields(projectName=projectName, databaseDirectory=databaseDirectory)
	print userFields	
	

if __name__ == "__main__":
	main()
