#!/usr/bin/python

import os
import pwd

import shutil

import errno

import subprocess

if __name__ == '__main__':
	# get installation directory
	processOwner = os.getuid()

	if processOwner != 0:
		print "root should run this program"
	else:
		# check dependencies
		# pydicom
		missingDeps = []
		
		try:	
			from lxml import etree
		except ImportError, e:
			missingDeps.append("lxml")
		try:	
			from math import sqrt
		except ImportError, e:
			missingDeps.append("math")
		try:	
			from numpy import *
		except ImportError, e:
			missingDeps.append("numpy")
		try:	
			import dicom
		except ImportError, e:
			missingDeps.append("pydicom")
		try:	
			import ezPyCrypto
		except ImportError, e:
			missingDeps.append("ezPyCrypto")
		try:	
			import gobject
		except ImportError, e:
			missingDeps.append("gtk")
		try:	
			import gtk
		except ImportError, e:
			missingDeps.append("pygtk")
		try:	
			import hashlib
		except ImportError, e:
			missingDeps.append("hashlib")
		try:	
			import math
		except ImportError, e:
			missingDeps.append("math")
		try:	
			import pygtk
		except ImportError, e:
			missingDeps.append("pygtk")
		try:	
			import posix1e
		except ImportError, e:
			missingDeps.append("pylibacl")

		if len(missingDeps) > 0:
			print "Error - The following dependencies have not been satisfied: " + ", ".join(missingDeps)
			print "Please install them before running setup.py"
			quit()

		defaultInstallationDirectory = '/usr/local/dfbidb'
		userInstallationDirectory = raw_input("Installation base directory [" + defaultInstallationDirectory + "]: ")
		if len(userInstallationDirectory) == 0:
			installationDirectory = defaultInstallationDirectory
		else:
			(head, tail) = os.path.split(userInstallationDirectory)
			if not os.path.isdir(head):
				print "the installation directory specified requires that " + head + " exists"
				exit()
			else:
				installationDirectory = userInstallationDirectory

		defaultDatabaseDirectory = '/var/lib/dfbidb'
		userDatabaseDirectory = raw_input("Default database directory [" + defaultDatabaseDirectory + "]: ")
		
		if len(userDatabaseDirectory) == 0:
			databaseDirectory = defaultDatabaseDirectory
		else:
			(head, tail) = os.path.split(userDatabaseDirectory)
			if not os.path.isdir(head):
				print "the database directory specified requires that " + head + " exists"
				exit()
			else:
				databaseDirectory = userDatabaseDirectory
		
		while 1:
			userUserID = raw_input("Database owner (user name on this system): ")
			
			if len(userUserID) == 0:
				print "A username is mandatory"
			else:
				try:
					userStats = pwd.getpwnam(userUserID)
					userID = userStats[2]
					groupID = userStats[3]
					break
				except Exception, e:
					print "The user name \"" + userUserID + "\" does not exist"
		
		# make installation directories
		try:
			os.mkdir(installationDirectory)
		except OSError, e:
			if e.errno != errno.EEXIST:
				raise

		try:
			os.mkdir(os.path.join(installationDirectory, 'bin'))
		except OSError, e:
			if e.errno != errno.EEXIST:
				raise


		# copy the binary files to the installation directory
		fileList = os.listdir('bin')
		for curFile in fileList:
			if os.path.isfile(os.path.join('bin', curFile)):
				shutil.copy(os.path.join('bin', curFile), os.path.join(installationDirectory, 'bin', curFile))

		#replace the default database directory in DataTransferConstants with the one specified here
		SourceDataTransferConstants = file(os.path.join('bin', 'DataTransferConstants.py'), 'r')
		DestDataTransferConstants = file(os.path.join(installationDirectory, 'bin', 'DataTransferConstants.py'), 'w')
		for curLine in SourceDataTransferConstants.xreadlines():
			if curLine == "databaseDirectory = '####'\n":
				DestDataTransferConstants.write("databaseDirectory = '" + databaseDirectory + "'")
			else:
				DestDataTransferConstants.write(curLine)
				
		SourceDataTransferConstants.close()
		DestDataTransferConstants.close()

		#os.mkdir(databaseDirectory)
		# create the database
		subprocess.call([os.path.join(installationDirectory, 'bin', 'dt_create_database.py'), databaseDirectory])

		os.chown(databaseDirectory, userID, groupID)
		for root, dirs, files in os.walk(databaseDirectory):
			for curDir in dirs:
				os.chown(os.path.join(root, curDir), userID, groupID)
			for curFile in files:
				os.chown(os.path.join(root, curFile), userID, groupID)
